#if defined(__linux__)
#if defined(__hppa__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       313

#define SYS_sigaction   174
#define SYS_sigprocmask 175

#define SYS_getpid       20
#define SYS_getppid      64
#define SYS_getsid      147
#define SYS_setsid       66
#define SYS_getpgid     132
#define SYS_setpgid      57
#define SYS_getpgrp      65

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getdents    141
#define SYS_getcwd      110

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_exit, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__fork
	.type	__fork, @function
__fork:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_fork, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__wait4
	.type	__wait4, @function
__wait4:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_wait4, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__kill
	.type	__kill, @function
__kill:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_kill, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__execve
	.type	__execve, @function
__execve:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_execve, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__read
	.type	__read, @function
__read:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_read, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__write
	.type	__write, @function
__write:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_write, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__open
	.type	__open, @function
__open:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_open, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__close
	.type	__close, @function
__close:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_close, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__dup
	.type	__dup, @function
__dup:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_dup, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__pipe
	.type	__pipe, @function
__pipe:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_pipe, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__dup2
	.type	__dup2, @function
__dup2:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_dup2, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__pipe2
	.type	__pipe2, @function
__pipe2:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_pipe2, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__sigaction
	.type	__sigaction, @function
__sigaction:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_sigaction, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__sigprocmask
	.type	__sigprocmask, @function
__sigprocmask:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_sigprocmask, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__getpid
	.type	__getpid, @function
__getpid:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getpid, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__getppid
	.type	__getppid, @function
__getppid:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getppid, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__getsid
	.type	__getsid, @function
__getsid:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getsid, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__setsid
	.type	__setsid, @function
__setsid:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_setsid, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__getpgid
	.type	__getpgid, @function
__getpgid:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getpgid, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__setpgid
	.type	__setpgid, @function
__setpgid:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_setpgid, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__getpgrp
	.type	__getpgrp, @function
__getpgrp:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getpgrp, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__chdir
	.type	__chdir, @function
__chdir:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_chdir, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_ioctl, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__brk
	.type	__brk, @function
__brk:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_brk, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	__getdents
	.type	__getdents, @function
__getdents:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getdents, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop

	.globl	____getcwd
	.type	____getcwd, @function
____getcwd:
	copy	%r19, %r4
	ble	0x100(%sr2, %r28)
	ldi	SYS_getcwd, %r20
	copy	%r4, %r19
	bv	%r0(%rp)
	nop
#endif
#endif
